#!/usr/bin/env node

var iGetAssertion = require('node-aws-adfs') ;
var readlineSync = require('readline-sync');
var argv = require('optimist').argv;
var fs = require('fs') ;
var os = require('os') ;
var oshome =os.homedir() ;


var myconfig = null ;
if (fs.existsSync(oshome + '/.aws/node-aws-adfs.json' )) {
    // console.log('Found file');
    myconfig = require(oshome + '/.aws/node-aws-adfs.json');
} else {
  myconfig = { 
    "email" : null,
    "workgroup": null,
    "adfsserver": null,
 }
}



// #######################################
var email =         argv.email      || myconfig.email     || null  ;
var adfsserver =    argv.adfsserver || myconfig.adfsserver || null ;
var workgroup =     argv.workgroup  || myconfig.workgroup  || null ;
var awsregion    =  argv.awsregion  || myconfig.awsregion  || "ap-southeast-2" ;
var getRolesF  =    argv.r ;
var getAuthWrite =  argv.w ;
var getHelp =       argv.h ;


if ( getHelp ) {
  getHelpF() ;
}

var pass = readlineSync.question('Password:', {
    hideEchoBack: true,
});

if ( email  &&   adfsserver   ) {
  //  console.log (   email ,  adfsserver  );

} else {
  getHelpF() ;
}

//---------------------------------------------------------------
// Check which options were called.
if ( getAuthWrite ) {
    // if no workgroup specified, ask user to pick.
    if( workgroup === null )  {
      workgroup =  askPassGetRoles( email  ,  adfsserver,   workgroup, awsregion ) ;
    }
  
  // If just show roles, do not write to cred file.
  } else if ( getRolesF ) {
     //console.log( "WORKGRP=" , workgroup)
     askPassGetRoles( email  ,  adfsserver,   workgroup, awsregion ) ;
  } else {
     // Defualt action. Assumes workgroup already sorted. Write to cred file
     askPassCredWrite( email  ,  adfsserver,   workgroup, awsregion ) ;
}
//---------------------------------------------------------------



//---------------------------------------------------------------
// my getHelp function.
//
function getHelpF() {
  help = 'usage: [-r (get Roles) OR -w (write config, defualt) ] OPTIONS\n' +
  'example: aws-adfs-js -w --email firstname.surname@uni.edu --adfsserver login.uni.edu --workgroup POC-WORKGROUP --awsregion ap-southeast-2';
  console.log(help);
  process.exit(0);
}
//---------------------------------------------------------------


//---------------------------------------------------------------
// Function to return the AWS Roles.
//
function askPassGetRoles(email,adfsserver,workgroup, awsregion) {
    // console.log("Get assertion with pass")
    iGetAssertion.getAWSRoles( email,   pass,  adfsserver  , awsregion ).then(function(response) {
      var index = "null"
      var slection = "";
      var size = 30;
      var pagecounter = 0;
      for (var i = 0; i < response.length; i += size) {
        var smallarray = response.slice(i, i + size);
        index = readlineSync.keyInSelect(smallarray, null, {
          cancel: 'Next page'
        });
        if (index === -1) {
          pagecounter = pagecounter + size
        } else {
          //console.log("BREAK")
          pagecounter = pagecounter + index
          break;
        }
      }
      
  selection = response[pagecounter]
    console.log("your selection =",  selection  )
    return selection

    }).catch(function(errr) {
      console.log("Error", errr)
    })
}
//---------------------------------------------------------------


//---------------------------------------------------------------
// Function call to write .aws/crededntial file.
//
function askPassCredWrite(email,adfsserver,workgroup,awsregion) {
    iGetAssertion.writeAWSCredFile( email,   pass,  adfsserver , workgroup, awsregion )
    // console.log("Done")
}
//---------------------------------------------------------------

